/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
	flowsv1 "knative.dev/eventing/pkg/apis/flows/v1"
)

// SequenceLister helps list Sequences.
// All objects returned here must be treated as read-only.
type SequenceLister interface {
	// List lists all Sequences in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*flowsv1.Sequence, err error)
	// Sequences returns an object that can list and get Sequences.
	Sequences(namespace string) SequenceNamespaceLister
	SequenceListerExpansion
}

// sequenceLister implements the SequenceLister interface.
type sequenceLister struct {
	listers.ResourceIndexer[*flowsv1.Sequence]
}

// NewSequenceLister returns a new SequenceLister.
func NewSequenceLister(indexer cache.Indexer) SequenceLister {
	return &sequenceLister{listers.New[*flowsv1.Sequence](indexer, flowsv1.Resource("sequence"))}
}

// Sequences returns an object that can list and get Sequences.
func (s *sequenceLister) Sequences(namespace string) SequenceNamespaceLister {
	return sequenceNamespaceLister{listers.NewNamespaced[*flowsv1.Sequence](s.ResourceIndexer, namespace)}
}

// SequenceNamespaceLister helps list and get Sequences.
// All objects returned here must be treated as read-only.
type SequenceNamespaceLister interface {
	// List lists all Sequences in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*flowsv1.Sequence, err error)
	// Get retrieves the Sequence from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*flowsv1.Sequence, error)
	SequenceNamespaceListerExpansion
}

// sequenceNamespaceLister implements the SequenceNamespaceLister
// interface.
type sequenceNamespaceLister struct {
	listers.ResourceIndexer[*flowsv1.Sequence]
}
